package probe

import (
	"git.loafle.net/overflow/commons-go/core/util"
	"git.loafle.net/overflow/commons-go/model/discovery"
)

type DiscoveryService interface {
	// By Central
	DiscoverZone(requesterID string, dz *discovery.DiscoveryZone) error
	DiscoverHost(requesterID string, zone *discovery.Zone, dh *discovery.DiscoveryHost) error
	DiscoverPort(requesterID string, host *discovery.Host, dp *discovery.DiscoveryPort) error
	DiscoverService(requesterID string, port *discovery.Port, dService *discovery.DiscoveryService) error
	// By Container
	DiscoveryStart(requesterID string, t *util.Timestamp) error
	DiscoveryStop(requesterID string, t *util.Timestamp) error
	DiscoveredZone(requesterID string, zone *discovery.Zone) error
	DiscoveredHost(requesterID string, host *discovery.Host) error
	DiscoveredPort(requesterID string, port *discovery.Port) error
	DiscoveredService(requesterID string, service *discovery.Service) error
}
